<?php

namespace Drupal\eca\Entity\Objects;

use Drupal\eca\Entity\Eca;

abstract class EcaObject {

  /**
   * @var \Drupal\eca\Entity\Eca
   */
  protected Eca $eca;

  /**
   * @var array
   */
  protected array $arguments = [];

  /**
   * @var array
   */
  protected array $successors = [];

  /**
   * @var string
   */
  protected string $id;

  /**
   * @var array
   */
  protected array $output = [];

  /**
   * Constructor.
   *
   * @param \Drupal\eca\Entity\Eca $eca
   * @param string $id
   */
  public function __construct(Eca $eca, string $id) {
    $this->eca = $eca;
    $this->id = $id;
  }

  /**
   * @param string $key
   * @param mixed $value
   *
   * @return $this
   */
  public function setArgument(string $key, $value): EcaObject {
    $this->arguments[$key] = $value;
    return $this;
  }

  /**
   * @param array $successors
   *
   * @return $this
   */
  public function setSuccessors(array $successors): EcaObject {
    $this->successors = $successors;
    return $this;
  }

  /**
   * @return array
   */
  public function getSuccessors(): array {
    return $this->successors;
  }

  /**
   * @return string
   */
  public function getId(): string {
    return $this->id;
  }

  /**
   * @param \Drupal\eca\Entity\Objects\EcaObject $predecessor
   * @param \Symfony\Contracts\EventDispatcher\Event|\Symfony\Component\EventDispatcher\Event $event
   *
   * @return bool
   */
  public function execute(EcaObject $predecessor, $event): bool {
    return TRUE;
  }

  /**
   * @return array
   */
  public function getOutput(): array {
    return $this->output;
  }

}
