<?php

namespace Drupal\eca\Plugin\Action;

use Drupal;
use Drupal\Core\Action\ActionBase;
use Drupal\Core\Session\AccountInterface;

/**
 * Load current entity into token environment.
 *
 * @Action(
 *   id = "eca_load_entity",
 *   label = @Translation("Load current entity into token"),
 *   type = "entity"
 * )
 */
class LoadEntity extends ActionBase {

  /**
   * {@inheritdoc}
   */
  public function execute($entity = NULL): void {
    if ($entity === NULL) {
      return;
    }
    Drupal::service('eca.service.token')->addTokenData($entity->getEntityTypeId(), $entity);
  }

  /**
   * {@inheritdoc}
   */
  public function access($object, AccountInterface $account = NULL, $return_as_object = FALSE) {
    /** @var \Drupal\Core\Entity\ContentEntityInterface $object */
    $result = $object->access('view', $account, TRUE);
    return $return_as_object ? $result : $result->isAllowed();
  }

}
