<?php

namespace Drupal\eca\Plugin\Action;

use Drupal\Core\Access\AccessResult;
use Drupal\Core\Action\ActionBase;
use Drupal\Core\Session\AccountInterface;

/**
 * Empty action to chain conditions with AND constraint.
 *
 * @Action(
 *   id = "eca_void_and_condition",
 *   label = @Translation("Chain action for AND condition")
 * )
 */
class VoidForAndCondition extends ActionBase {

  /**
   * {@inheritdoc}
   */
  public function execute(): void {}

  /**
   * {@inheritdoc}
   */
  public function access($object, AccountInterface $account = NULL, $return_as_object = FALSE) {
    $result = AccessResult::allowed();
    return $return_as_object ? $result : $result->isAllowed();
  }

}
