<?php

namespace Drupal\eca;

/**
 *
 */
abstract class PluginConditionBase extends PluginBase implements PluginConditionInterface {

  public const OPTION_NO = 'no';
  public const OPTION_YES = 'yes';

  /**
   * {@inheritdoc}
   */
  final public function assertCondition(): bool {
    if (isset($this->configuration['negate']) && $this->configuration['negate'] === self::OPTION_YES) {
      return !$this->assertConditions();
    }
    return $this->assertConditions();
  }

  /**
   * {@inheritdoc}
   */
  public function fields(): array {
    return [[
      'name' => 'negate',
      'label' => 'Negate this condition',
      'type' => 'Dropdown',
      'value' => self::OPTION_NO,
      'extras' => [
        'choices' => [
          [
            'name' => 'no',
            'value' => self::OPTION_NO,
          ],
          [
            'name' => 'yes',
            'value' => self::OPTION_YES,
          ],
        ],
      ],
    ]];
  }

}
